"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.isObject = isObject;
exports.isDevelopment = isDevelopment;
exports.toError = toError;
exports.isRefArray = isRefArray;
exports.extractRefSchema = extractRefSchema;
function isObject(obj) {
  return (typeof obj === "undefined" ? "undefined" : _typeof(obj)) === "object" && obj !== null;
}

function isDevelopment() {
  return process.env.NODE_ENV !== "production";
}

function toError(message) {
  if (isDevelopment()) {
    throw new ReferenceError(message);
  } else {
    console.error(message);
  }
}

function isRefArray(field, schema) {
  return schema.properties[field] && schema.properties[field].type === "array" && schema.properties[field].items && schema.properties[field].items["$ref"];
}

function fetchSchema(ref, schema) {
  var relevantSchema = ref.split("/");
  return relevantSchema.filter(function (ref) {
    return ref !== "#";
  }).reduce(function (schema, field) {
    return schema[field];
  }, schema);
}

function extractRefSchema(field, schema) {
  if (isRefArray(field, schema)) {
    return fetchSchema(schema.properties[field].items["$ref"], schema);
  } else if (schema.properties[field] && schema.properties[field]["$ref"]) {
    return fetchSchema(schema.properties[field]["$ref"], schema);
  } else {
    return undefined;
  }
}

var concat = function concat(x, y) {
  return x.concat(y);
};
var flatMap = exports.flatMap = function flatMap(xs, f) {
  return xs.map(f).reduce(concat, []);
};